package embedutil

import (
	"bytes"
	"fmt"
	"io"
	"os"
	"path/filepath"
	"strings"

	"github.com/charmbracelet/x/ansi"
	"github.com/spf13/cobra"
	"gitlab.com/act3-ai/asce/go-common/pkg/options/cobrautil"
	"gitlab.com/act3-ai/asce/go-common/pkg/options/flagutil"
	"gitlab.com/act3-ai/asce/go-common/pkg/termdoc"
)

// adapted from: https://gitlab.com/gitlab-org/cli/-/blob/main/cmd/gen-docs/docs.go

func renderMarkdownTree(cmd *cobra.Command, dir string, opts *Options) error {
	name := commandFilePath(cmd, opts)

	dest := filepath.Join(dir, name)

	// create parent directory
	err := os.MkdirAll(filepath.Dir(dest), 0o775)
	if err != nil {
		return fmt.Errorf("command docs: %w", err)
	}

	buf := new(bytes.Buffer)

	// Generate command
	err = GenMarkdownCustom(cmd, buf)
	if err != nil {
		return err
	}

	content := buf.String()
	content = ansi.Strip(content)

	err = os.WriteFile(dest, []byte(content), 0o644)
	if err != nil {
		return fmt.Errorf("command docs: %w", err)
	}

	for _, cmdC := range cmd.Commands() {
		if cmdC.Name() == "help" {
			continue // skip help commands
		}

		err = renderMarkdownTree(cmdC, dir, opts)
		if err != nil {
			return err
		}
	}

	return nil
}

func commandFilePath(cmd *cobra.Command, opts *Options) string {
	switch {
	case opts.Flat:
		// Flat output writes all files using the full command path
		return strings.ReplaceAll(cmd.CommandPath(), " ", "_") + ".md"
	case cmd.HasAvailableSubCommands():
		// Parent of a command group is written to <name>/index.md
		name := filepath.Join(strings.Split(cmd.CommandPath(), " ")[1:]...)
		name = filepath.Join(name, "index.md")
		return name
	default:
		// Member of a command group is written to <parent>/<name>.md
		return filepath.Join(strings.Split(cmd.CommandPath(), " ")[1:]...) + ".md"
	}
}

func printSubcommands(cmd *cobra.Command, buf *bytes.Buffer) {
	if !cmd.HasAvailableSubCommands() {
		return
	}

	var subcommands string

	// Generate children commands
	for _, cmdC := range cmd.Commands() {
		if cmdC.Name() == "help" {
			continue // skip help commands
		}

		if cmdC.HasAvailableSubCommands() {
			subcommands += fmt.Sprintf("- [`%s`](%s/index.md)", cmdC.CommandPath(), cmdC.Name())
		} else {
			subcommands += fmt.Sprintf("- [`%s`](%s.md)", cmdC.CommandPath(), cmdC.Name())
		}
		if cmdC.Short != "" {
			subcommands += " - " + cmdC.Short
		}
		subcommands += "\n"
	}

	if subcommands != "" {
		buf.WriteString("\n## Subcommands\n\n")
		buf.WriteString(subcommands)
	}
}

// GenMarkdownCustom creates custom Markdown output. github.com/spf13/cobra/blob/main/doc/md_docs.go
func GenMarkdownCustom(cmd *cobra.Command, w io.Writer) error {
	// cmd.InitDefaultHelpCmd()
	cmd.InitDefaultHelpFlag()

	buf := new(bytes.Buffer)

	// Frontmatter (for MkDocs)
	buf.WriteString("---" + "\n")
	buf.WriteString("title: " + cmd.CommandPath() + "\n")
	buf.WriteString("description: " + cmd.Short + "\n")
	buf.WriteString("---" + "\n\n")

	// Generated by a script
	buf.WriteString("<!--" + "\n")
	buf.WriteString("This documentation is auto generated by a script." + "\n")
	buf.WriteString("Please do not edit this file directly." + "\n")
	buf.WriteString("-->" + "\n\n")

	// Disable markdowlint single title rule for the next line
	buf.WriteString("<!-- markdownlint-disable-next-line single-title -->\n")

	var done bool
	if cmd.IsAdditionalHelpTopicCommand() {
		if termdoc.HasLazyLongMessage(cmd) {
			cmd.SetOut(io.Discard)
			cmd.SetErr(io.Discard)
			cmd.HelpFunc()(cmd, []string{})
		}
		if cmd.Long != "" {
			buf.WriteString(cmd.Long + "\n")
			done = true
		}
	}

	if !done {
		buf.WriteString("# " + cmd.CommandPath() + "\n")

		if len(cmd.Short) > 0 {
			buf.WriteString("\n" + cmd.Short + "\n")
		}

		if len(cmd.Long) > 0 {
			buf.WriteString("\n## Synopsis\n\n")
			buf.WriteString(cmd.Long + "\n")
		}

		if cmd.Runnable() {
			buf.WriteString(fmt.Sprintf("\n## Usage\n\n```plaintext\n%s\n```\n", cmd.UseLine()))
		}

		if len(cmd.Aliases) > 0 {
			buf.WriteString("\n## Aliases\n\n```plaintext\n")
			for _, a := range cmd.Aliases {
				buf.WriteString(fmt.Sprintf("%s %s\n", cmd.Parent().CommandPath(), a))
			}
			buf.WriteString("```\n")
		}

		if len(cmd.Example) > 0 {
			buf.WriteString("\n## Examples\n\n")
			buf.WriteString(fmt.Sprintf("```sh\n%s\n```\n", cmd.Example))
		}

		printOptions(buf, cmd)

		printSubcommands(cmd, buf)
	}

	_, err := buf.WriteTo(w)
	if err != nil {
		return fmt.Errorf("command docs: %w", err)
	}

	return nil
}

var defaultUsageFormat = cobrautil.UsageFormatOptions{
	Format:      cobrautil.Formatter{},
	FlagOptions: flagutil.UsageFormatOptions{},
	LocalFlags: cobrautil.FlagGroupingOptions{
		GroupFlags:      true,
		UngroupedHeader: cobrautil.DefaultLocalFlagHeader,
	},
	InheritedFlags: cobrautil.FlagGroupingOptions{
		GroupFlags:      true,
		UngroupedHeader: cobrautil.DefaultGlobalFlagHeader,
	},
}

// SetUsageFormat sets common formatting for usage documentation.
func SetUsageFormat(opts cobrautil.UsageFormatOptions) {
	defaultUsageFormat = opts
}

func printOptions(buf *bytes.Buffer, cmd *cobra.Command) {
	if localFlags := cmd.LocalFlags(); localFlags.HasAvailableFlags() {
		buf.WriteString("\n## Options\n\n")
		buf.WriteString("```plaintext\n")
		buf.WriteString(cobrautil.LocalFlagUsages(cmd, defaultUsageFormat))
		buf.WriteString("```\n")
	}

	if parentFlags := cmd.InheritedFlags(); parentFlags.HasAvailableFlags() {
		buf.WriteString("\n## Options inherited from parent commands\n\n")
		buf.WriteString("```plaintext\n")
		buf.WriteString(cobrautil.InheritedFlagUsages(cmd, defaultUsageFormat))
		buf.WriteString("```\n")
	}
}
